**/

public class ExtrasEventsProcedure extends Event {

  public ExtrasEventsProcedure() {}

  @Cancelable
  public static class InventoryInteraction extends ExtrasEventsProcedure {
    private final Entity entity;
    private final int slotId;
    private boolean isArmor;
    private ItemStack previousItem;
    private ItemStack targetItem;
    private ExtrasTypesProcedure actionTypeValue;

    public InventoryInteraction(Entity entity, int slotId, boolean isArmor,ItemStack PreviousItem, ItemStack targetItem,Object actionType) {
        this.entity = entity;
        this.slotId = slotId;
        this.isArmor = isArmor;
        this.targetItem = targetItem;
        this.previousItem = PreviousItem;
        this.actionTypeValue = new ExtrasTypesProcedure(actionType);
    }

    public ItemStack getCurrentItem() {
        return targetItem;
    }

    public ItemStack getPreviousItem() {
        return previousItem;
    }

    public Entity getEntity() {
        return entity;
    }

    public int getSlotId() {
        return slotId;
    }

    public boolean isArmor() {
        return isArmor;
    }

    public Object getStringActionType() {
        return this.actionTypeValue.get();
    }
  }
  
  public static class ItemThrown extends InventoryInteraction {
    private final Entity entity;
    private final int slotId;
    private ItemStack thrownItem;

    public ItemThrown(Entity entity, int slotId, ItemStack thrownItem) {
        this.entity = entity;
        this.slotId = slotId;
        this.thrownItem = thrownItem;
    }

    public Entity getThrowPlayerEntity() {
        return entity;
    }

    public int getThrownSlotId() {
        return slotId;
    }

    public ItemStack ThrownedItem() {
        return thrownItem;
    }
  }
