    BlockEntity pBlockEntity = world.getBlockEntity( new BlockPos(${input$x},${input$y},${input$z}) );
    ItemStack displayedItem = ItemStack.EMPTY;
    int outSlot = ${input$outslot};
    boolean set = false;
    boolean interact = true;
    int slots  = SlotCount(pBlockEntity);
    Map<Integer, CraftInstance> target_info = null;

    ${statement$foreach}

			if (target_info != null && interact) {
			setString(pBlockEntity, world, encode(target_info));
		}
		if (interact) {
			setItemStack(pBlockEntity, displayedItem, outSlot);
		}
	}

public static String encode(Map<Integer, CraftInstance> map) {
  StringBuilder mapAsString = new StringBuilder("{");
  for (Integer key : map.keySet()) {
      mapAsString.append(key + "=" + CraftInstance.toString(map.get(key)) + ", ");
  }
  mapAsString.delete(mapAsString.length()-2, mapAsString.length()).append("}");
  return mapAsString.toString();
}

public static Map<Integer, CraftInstance> decode(String map) {
  Map<Integer, CraftInstance> mapFromString = new HashMap<>();
  String[] entries = map.substring(1, map.length() - 1).split(", ");
  for (String entry : entries) {
      String[] parts = entry.split("=");
      int key = Integer.parseInt(parts[0]);
      CraftInstance value = CraftInstance.fromString(parts[1]);
      mapFromString.put(key, value);
  }
  return mapFromString;
}


	public static void setString(BlockEntity _blockEntity, LevelAccessor world, String encoded) {
		BlockPos _bp = _blockEntity.getBlockPos();
		BlockState _bs = world.getBlockState(_bp);
		if (_blockEntity != null)
			_blockEntity.getPersistentData().putString("craft_map", encoded);
		if (world instanceof Level _level)
			_level.sendBlockUpdated(_bp, _bs, _bs, 3);
	}

	public static String getString(BlockEntity pBlockEntity) {
		return pBlockEntity.getPersistentData().getString("craft_map");
	}

	public static void add(Map<Integer, CraftInstance> CRAFT_INSTANCES, ItemStack item, int slotid, int count, boolean strict, int actionType, String recipe) {
		CRAFT_INSTANCES.put(slotid, new CraftInstance(item.copy(), slotid, count, strict, actionType, recipe));
	}

	public static class CraftInstance {
		public ItemStack item;
		public int slotid;
		public int count;
		public boolean strict;
		public int actionType; // 0 None , 1 Consume , 2 Damage
		public String recipe_name;

		public CraftInstance(ItemStack item, int slotid, int count, boolean strict, int actionType, String recipe_name) {
			this.item = item;
			this.slotid = slotid;
			this.count = count;
			this.strict = strict;
			this.actionType = actionType;
			this.recipe_name = recipe_name;
		}

		public static String toString(CraftInstance CI) {
			return (ForgeRegistries.ITEMS.getKey(CI.item.getItem() ).toString())+"|"+CI.slotid+"|"+CI.count+"|"+CI.strict+"|"+CI.actionType+"|"+CI.recipe_name;
		}

		public static CraftInstance fromString(String str) {
   String[] parts = str.split("\\|");
   if (parts.length != 6) {
       throw new IllegalArgumentException("Invalid string format");
   }

   ResourceLocation itemResourceLocation = new ResourceLocation(parts[0]);
   Item item = ForgeRegistries.ITEMS.getValue(itemResourceLocation);
   if (item == null) {
       throw new IllegalArgumentException("Unknown item: " + parts[0]);
   }

   int slotid = Integer.parseInt(parts[1]);
   int count = Integer.parseInt(parts[2]);
   boolean strict = Boolean.parseBoolean(parts[3]);
   int actionType = Integer.parseInt(parts[4]);
   String recipe_name = parts[5];

   return new CraftInstance(new ItemStack(item), slotid, count, strict, actionType, recipe_name);
}

	}

	public static boolean canCraft(Map<Integer, CraftInstance> CRAFT_INSTANCES, BlockEntity pBlockEntity, int slots, List<Integer> IGNORE_LIST) {
		for (int pos = 0; pos < slots; pos++) {
			if (!IGNORE_LIST.contains(pos)) {
				CraftInstance inst = CRAFT_INSTANCES.get(pos);
				if (inst != null) {
					if (!meetCondition(inst, pBlockEntity)) {
						return false;
					}
				} else {
					ItemStack itemStack = getItemStack(pBlockEntity, pos, false);
					if (!itemStack.isEmpty()) {
						return false;
					}
				}
			}
		}
		return true;
	}

	public static boolean meetCondition(CraftInstance CI, BlockEntity pBlockEntity) {
		ItemStack itemStack = getItemStack(pBlockEntity, CI.slotid, CI.strict);
		boolean itemMatch = itemStack.getItem() == CI.item.getItem();
		boolean tagMatch = true;
		boolean countMatch = itemStack.getCount() >= CI.count;

		if (CI.strict==true) {
			tagMatch = itemStack.hasTag() && CI.item.hasTag() && itemStack.getTag().equals(CI.item.getTag());
		}
		
		return itemMatch && countMatch && tagMatch; 
	}

	public static int SlotCount(BlockEntity pBlockEntity) {
		AtomicReference<IItemHandler> _iitemhandlerref = new AtomicReference<>();
		pBlockEntity.getCapability(ForgeCapabilities.ITEM_HANDLER, null).ifPresent(capability -> _iitemhandlerref.set(capability));
		if (_iitemhandlerref.get() != null) {
			return _iitemhandlerref.get().getSlots();
		}
		return 0;
	}

	public static ItemStack getItemStack(BlockEntity pBlockEntity, int slotid, boolean strict) {
		AtomicReference<ItemStack> _retval = new AtomicReference<>(ItemStack.EMPTY);
		pBlockEntity.getCapability(ForgeCapabilities.ITEM_HANDLER, null).ifPresent(capability -> _retval.set(capability.getStackInSlot(slotid).copy()));
		if (strict == true) {
			return _retval.get();
		}
		return new ItemStack(_retval.get().getItem());
	}

	public static void setItemStack(BlockEntity pBlockEntity, ItemStack _setstack, int slotid) {
		pBlockEntity.getCapability(ForgeCapabilities.ITEM_HANDLER, null).ifPresent(capability -> {
			if (capability instanceof IItemHandlerModifiable)
				((IItemHandlerModifiable) capability).setStackInSlot(slotid, _setstack);
		});
	}

	public static void removeItemStack(BlockEntity pBlockEntity, int slotid, int count) {
		pBlockEntity.getCapability(ForgeCapabilities.ITEM_HANDLER, null).ifPresent(capability -> {
			if (capability instanceof IItemHandlerModifiable) {
				ItemStack _stk = capability.getStackInSlot(slotid).copy();
				_stk.shrink(count);
				((IItemHandlerModifiable) capability).setStackInSlot(slotid, _stk);
			}
		});
	}

	public static void damageItemStack(BlockEntity pBlockEntity, int slotid, int count) {
		pBlockEntity.getCapability(ForgeCapabilities.ITEM_HANDLER, null).ifPresent(capability -> {
			if (capability instanceof IItemHandlerModifiable) {
				ItemStack _stk = capability.getStackInSlot(slotid).copy();
				if (_stk.hurt(count, RandomSource.create(), null)) {
					_stk.shrink(1);
					_stk.setDamageValue(0);
				}
				((IItemHandlerModifiable) capability).setStackInSlot(slotid, _stk);
			}
		});
	}

	private void nil() {
