**/

public class ExtrasEventsHandlerProcedure {
    
private Map<Entity, ItemStack[]> playerInventories = new HashMap<>();

@SubscribeEvent
public void onPlayerTick(TickEvent.PlayerTickEvent event) {
    Entity player = event.player;

    int totalSlots = 36 + 4; // 4 armor slots
    ItemStack[] currentInventory = new ItemStack[totalSlots];
    for (int i = 0; i < totalSlots; i++) {
        if (i < 36) {
            currentInventory[i] = new Object() {
                public ItemStack getItemStack(int sltid, Entity entity) {
                    AtomicReference<ItemStack> _retval = new AtomicReference<>(ItemStack.EMPTY);
                    entity.getCapability(ForgeCapabilities.ITEM_HANDLER, null).ifPresent(capability -> {
                        _retval.set(capability.getStackInSlot(sltid).copy());
                    });
                    return _retval.get();
                }
            }.getItemStack(i, player);
        } else {
            EquipmentSlot slotType;
            switch (i - 36) {
                case 0:
                    slotType = EquipmentSlot.FEET;
                    break;
                case 1:
                    slotType = EquipmentSlot.LEGS;
                    break;
                case 2:
                    slotType = EquipmentSlot.CHEST;
                    break;
                default:
                    slotType = EquipmentSlot.HEAD;
            }
            currentInventory[i] = (player instanceof LivingEntity) ? ((LivingEntity)player).getItemBySlot(slotType) : ItemStack.EMPTY;
        }
    }

    ItemStack[] previousInventory = playerInventories.get(player);

    if (previousInventory == null) {
        previousInventory = currentInventory.clone();
        playerInventories.put(player, previousInventory);
    }

    // Check each slot in the player's inventory
    for (int i = 0; i < totalSlots; i++) {
        ItemStack currentItem = currentInventory[i];
        ItemStack previousItem = previousInventory[i];

        if (!(currentItem==previousItem) ) {
            boolean isArmor = i >= 36;
            Object actionType;
            if (previousItem.getItem() == Blocks.AIR.asItem()) {
                actionType = 11;
            } else if (currentItem.getItem() == Blocks.AIR.asItem()) {
                actionType = 10;
            } else {
                actionType = 12;
            }
            ExtrasEventsProcedure.InventoryInteraction inventoryEvent = new ExtrasEventsProcedure.InventoryInteraction(player, i, isArmor, previousItem, currentItem, actionType);
            MinecraftForge.EVENT_BUS.post(inventoryEvent);

            if (inventoryEvent.isCanceled()) {
                break;
            } else {
                // Update the item in the copied inventory
                previousInventory[i] = currentItem.isEmpty() ? ItemStack.EMPTY : currentItem.copy();
            }
        }
    }
